import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class _070207_Wachstum extends PApplet {//--------------------------------------------------------------------------
// Globale Variabeln
//--------------------------------------------------------------------------

int Hintergrund = color (230);                                 // Hintergrundfarbe
int ZelleColor = color (200, 200, 160);                        // Farbe wachsende Zelle
int c1 = color (229);                                          // Farbe Kreis innen
int c2 = color (200, 200, 160);                                // Farbe Kreis Mitte
int c3 = color (180, 180, 160);                                          // Farbe Kreis Mitte
int ZelleFertigColor = color (200);                            // Farbe fertige Zelle
int FensterColor = color (229);                                // Farbe Fenster
int AnzahlZellen = 500;                                          // Anzahl Zellen
int AnzahlOeffnungen = 4;                                        // Anzahl \u00d6ffnungen
int minRandAbstand = 50;                                         // minimaler Abstand einer \u00d6ffnung zum Rand
int n = 0;                                                       // Z\u00e4hler Durchg\u00e4nge
int m = 5;                                                       // Anzal Wachstumsrunden pro Durchgang
float f = 0.05f;                                                   // Wachstum pro Durchgang
float g = 0.15f;                                                   // Verschiebung pro Durchgang
float Rand = 2;                                                   // Rand der Kreise
int maxB = 180;                                                  // maximale Fensterbreite
int minB = 50;                                                   // minimale Fensterbreite
int minR = 2;                                                    // minimaler rZelle einer Zelle
int minA = 2;                                                    // minimaler Abstand, darunter = ber\u00fchrt
boolean schlaufen = false;                                       // draw stoppen/starten \u00fcber Mausklick (>s. Funktionen)
boolean alleGezeichnet = false;                                  // Ende ermitteln

oZelle [] meineZelle = new oZelle [AnzahlZellen];                // Zellen-Array generieren
Oeffnung [] meineOeffnung = new Oeffnung [AnzahlOeffnungen];     // Oeffnungs-Array generieren

//--------------------------------------------------------------------------
// Initialisierung
//--------------------------------------------------------------------------

public void setup()
{
  size (600, 600);
  // frameRate (5);
  background (Hintergrund);

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier \u00d6ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [0] = new oZelle ();                                              // erste Zelle generieren
  meineZelle [0].zeichnen ();
  
  noLoop ();
}

//--------------------------------------------------------------------------
// Frame f\u00fcr Frame wiederholt
//--------------------------------------------------------------------------

public void draw ()
{

  for (int j = 1; j <= m; j++)                 // m-mal wachsen, bevor eine neue Zelle generiert wird
  {

    for (int i = 0; i <= n; i++)               // alle bestehenden Zellen "durchschlaufen"
    {
      if (meineZelle [i].getFertig () == false)                            // falls die Zelle noch nicht fertig ist
      {
        int Beruehrungen = meineZelle [i].BeruehrungenZaehlen ();          // Zelle testen
        if (Beruehrungen == 0)                                             // keine Ber\u00fchrung -> wachsen
        {
          meineZelle [i].wachsen();
        }
        else if (Beruehrungen == 1)                                         // 1 Ber\u00fchrung -> bewegen
        {
          meineZelle [i].loeschen();
          meineZelle [i].bewegen_Ber_1();
          meineZelle [i].wachsen();
        }
        else if (Beruehrungen == 2)                                         // 2 Ber\u00fchrung -> bewegen
        {
          meineZelle [i].loeschen();
          meineZelle [i].bewegen_Ber_2();
          meineZelle [i].wachsen();
        }
        else if (Beruehrungen == 3)
        {
           if (meineZelle [i].getGeometrie () [2] < minR)                   // wird neu gestartet, falls sie fertig, aber zu klein ist
          {
            meineZelle [i].reset ();          
          }
          else                                                              // Zelle wird als "fertig" deklariert
          {
            meineZelle [i].setFertig (true);
          }
        }
      }
    }

  }


  if (n < AnzahlZellen-1)                      // Z\u00e4hler erh\u00f6hen und neue Zelle generieren, falls Anzahl Zellen noch nicht erreicht ist
  {
    n++;
    meineZelle [n] = new oZelle ();             // neue Zelle generieren
    meineZelle [n].zeichnen ();                // generierte Zelle zeichnen
  }
  else if (alleGezeichnet == false)
  {
    println ("alle Zellen gezeichnet");
    alleGezeichnet = true;
  }

}



public int [] freieStelle ()
{
  int [] zufallsPos = new int [2];

  int xRandom = (int) random (width);                              // freie Stelle suchen
  int yRandom = (int) random (height);
  boolean frei = false; 

  while (frei == false)
  {
    if ((get(xRandom, yRandom)) == Hintergrund)
    {
      frei = true;
    }
    else
    {
      xRandom = (int) random (width);
      yRandom = (int) random (height);
    }
  }
  zufallsPos [0] = xRandom;
  zufallsPos [1] = yRandom;
  return zufallsPos;
}

//--------------------------------------------------------------------------------------------------

public void mouseClicked()
{
  if (schlaufen == true)
  {
    noLoop ();
    schlaufen = false;
  } 
  else if (schlaufen == false)
  {
    loop ();
    schlaufen = true;
  }
}

//--------------------------------------------------------------------------------------------------

public void keyPressed()                                                             // Programm neu starten
{
  background (Hintergrund);
  n = 0;                                                                      // n zur\u00fccksetzen

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier \u00d6ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [n] = new oZelle ();                                              // erste Zelle generieren
  meineZelle [n].zeichnen ();
  loop ();
  schlaufen = true;

}

//--------------------------------------------------------------------------------------------------

public float [] zeichne_KreisInKreis (float xUmfassung, float yUmfassung, float rUmfassung, float xKreis, float yKreis, float rKreis, int fKreis)           // zeichnet Kreis in einen Anderen
{
  float xU = xUmfassung;
  float yU = yUmfassung;
  float rU = rUmfassung;
  float xK = xKreis;                            // gibt Richtung des Ber\u00fchrungspunktes
  float yK = yKreis;
  float rK = rKreis;
  int f = fKreis;                             // Farbe des Kreises

    float xZentrum;
  float yZentrum;
  xZentrum = (rU / rK)*xK - xK;
  yZentrum = (rU / rK)*yK - yK;
  ellipseMode (CENTER_RADIUS);
  noStroke ();
  fill (f);
  if (rK > minA)
  {
    ellipse (xU + xZentrum, yU + yZentrum, rK-minA, rK-minA);
  }
  float [] Zentrum = new float [2];
  Zentrum [0] = xU + xZentrum;
  Zentrum [1] = yU + yZentrum;
  return Zentrum;
}  

//--------------------------------------------------------------------------------------------------

public void zeichne_Kreis (float xKreis, float yKreis, float rKreis, int fKreis)           // zeichnet Kreis
{

  float xK = xKreis;
  float yK = yKreis;
  float rK = rKreis;
  int f = fKreis;                             // Farbe des Kreises

  ellipseMode (CENTER_RADIUS);
  noStroke ();
  fill (f);
  ellipse (xK, yK, rK, rK);

}  

class Oeffnung
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  float x1;                // x-Wert links
  float x2;                // x-Wert rechts
  float y1;                // y-Wert oben
  float y2;                // y-Wert unten
  int col;               // Farbe

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Oeffnung (float l, float r, float o, float u)                    // Parameter: Parameter des Feldes der Oeffnung (links, rechts, oben, unten)
  {
    x1 = random (l + minRandAbstand, r - minRandAbstand - maxB);
    x2 = x1 + random (minB, maxB);
    y1 = random (o + minRandAbstand , u - minRandAbstand - maxB);
    y2 = y1 + random (minB, maxB);
  }

  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void zeichnen ()
  {
    fill (FensterColor);
    noStroke ();
    rectMode(CORNERS);
    rect (x1, y1, x2, y2);
  }

//--------------------------------------------------------------------------------------------------  

  public float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {x1, x2, y1, y2};
    return Geometrie;
  }  
  
//--------------------------------------------------------------------------------------------------


}

class oZelle extends Zelle
{
  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  float r1;                                // Radius bei der 1. Ber\u00fchrung
  float r2;                                // Radius bei der 2. Ber\u00fchrung
  float xB1;                               // relativer x-Wert bei der 1. Ber\u00fchrung
  float yB1;                               // relativer y-Wert bei der 1. Ber\u00fchrung  
  float xB2;                               // relativer x-Wert bei der 2. Ber\u00fchrung
  float yB2;                               // relativer y-Wert bei der 2. Ber\u00fchrung
  float [] z1 = new float [2];             // Koordinaten des Mittelpunkts des 1. Ber\u00fchrungskreises  
  float [] z2 = new float [2];             // Koordinaten des Mittelpunkts des 2. Ber\u00fchrungskreises  
  // color c1;                             // Farbe bei der 1. Ber\u00fchrung
  // color c2;                             // Farbe bei der 2. Ber\u00fchrung


  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  oZelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }



  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void setBeruehrungspunkt ()                          // Daten der Ber\u00fchrungen werden in Variabeln geschrieben
  {
    switch (AnzahlBeruehrungen)
    {
    case 1:
      r1 = rZelle;
      xB1 = Beruehrungspunkt [0] - xZelle;
      yB1 = Beruehrungspunkt [1] - yZelle;

    case 2:
      r2 = rZelle;
      xB2 = Beruehrungspunkt [2] - xZelle;
      yB2 = Beruehrungspunkt [3] - yZelle;
      
      /*
      float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
      float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
      float AbstandMitte = sqrt(sq(xMitte -xZelle) + sq(yMitte -yZelle));
      xB2 = r2/AbstandMitte * xMitte;
      yB2 = r2/AbstandMitte * yMitte;
      */
    }
  }    

  //--------------------------------------------------------------------------------------------------

  public void zeichnen ()                                      // \u00fcberdeckt die Methode in der Mutterklasse
  {
    switch (AnzahlBeruehrungen)
    {
    case 0:
      zeichne_Kreis (xZelle, yZelle, rZelle, c2);
      if (rZelle > Rand)
      {
        zeichne_Kreis (xZelle, yZelle, rZelle-Rand, c1);
      }
      break;

    case 1:
      zeichne_Kreis (xZelle, yZelle, rZelle, c2);
      z1 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB1, yB1, r1, c1);
      break;

    case 2:
      zeichne_Kreis (xZelle, yZelle, rZelle, c3);
      z2 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB2, yB2, r2, c2);
      z1 = zeichne_KreisInKreis (z2 [0], z2 [1], r2, xB1, yB1, r1, c1);
      break;
    }
  }  

  //--------------------------------------------------------------------------------------------------
  
  public void zeichnen_Kreis0a ()                                      // zeichnet Kreis der urspr\u00fcnglichen Kreis Ber\u00fchrung
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
    if (rZelle > Rand)
    {
      fill (c1);
      ellipse (xZelle, yZelle, rZelle-Rand, rZelle-Rand);
    }
  }  

  //--------------------------------------------------------------------------------------------------
  public void zeichnen_Kreis0b ()                                      // zeichnet Kreis der urspr\u00fcnglichen Kreis Ber\u00fchrung
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }  


  //--------------------------------------------------------------------------------------------------

  public void setFertig (boolean f)                           // \u00fcberdecket die Methode in Mutterklasse
  {
    fertig = f;
  }    

  // --------------------------------------------------------------------------------------------------
}

class Zelle
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  boolean fertig;
  int AnzahlBeruehrungen = 0;                          // effektive Anzahl Ber\u00fchrungen
  int Beruehrungszaehler = 0;                          // wird bei jedem Durchgang auf null gesetzt und von Neuem hochgez\u00e4hlt        
  float [] Beruehrungspunkt = new float [4];           // von den max. 2 Ber\u00fchrungspunkten werden die Koordinaten gespeichert
  int col;
  float xZelle;
  float yZelle;
  float rZelle;

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Zelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void entwickeln ()
  {
    if (fertig == false)                                                 // falls die Zelle noch nicht fertig ist
    {
      int Beruehrungen = BeruehrungenZaehlen ();                         // Zelle testen
      if (Beruehrungen == 0)                                             // keine Ber\u00fchrung -> wachsen
      {
        wachsen();
      }
      else if (Beruehrungen == 1)                                         // 1 Ber\u00fchrung -> bewegen
      {
        loeschen();
        bewegen_Ber_1();
        zeichnen();
      }
      else if (Beruehrungen == 2)                                         // 2 Ber\u00fchrung -> bewegen
      {
        loeschen();
        bewegen_Ber_2();
        zeichnen();
      }
      else if (Beruehrungen == 3)
      {
         if (rZelle < minR)                                               // wird neu gestartet, falls sie fertig, aber zu klein ist
        {
          reset ();          
        }
        else                                                              // Zelle wird als "fertig" deklariert
        {
          fertig = true;
        }
      }
    }
  }

  //--------------------------------------------------------------------------------------------------

  
  
  
  
  
  
  public void zeichnen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (col);
    ellipse (xZelle, yZelle, rZelle, rZelle);
    fill (Hintergrund);
    ellipse (xZelle, yZelle, rZelle-2, rZelle-2);
  }

  //--------------------------------------------------------------------------------------------------

  public void loeschen ()
  {
    ellipseMode (CENTER_RADIUS);
    noStroke ();
    fill (Hintergrund);
    ellipse (xZelle, yZelle, rZelle, rZelle);
  }

  //--------------------------------------------------------------------------------------------------

  public void wachsen ()
  {
    rZelle += f;
    zeichnen ();
  }

  //--------------------------------------------------------------------------------------------------

  public int BeruehrungenZaehlen ()
  {
    Beruehrungszaehler = 0;

// Zellen

    for (int i=0; i<=n; i++)
    {
      float xNachbar = meineZelle [i].getGeometrie () [0];
      float yNachbar = meineZelle [i].getGeometrie () [1];
      float rNachbar = meineZelle [i].getGeometrie () [2];
      float Abstand = sqrt(sq(xNachbar - xZelle) + sq(yNachbar -yZelle));

      if (Abstand <= rZelle + minA + rNachbar && Abstand != 0)                                                          // Ber\u00fchrung
      {
        setBerKoor (xZelle + (rZelle/Abstand)*(xNachbar - xZelle), yZelle + (rZelle/Abstand)*(yNachbar - yZelle));      // Koordinaten Ber\u00fchrungspunkt setzen
      }
    }

// \u00d6ffnungen

    for (int i=0; i < AnzahlOeffnungen; i++)
    {
      float xL = meineOeffnung [i].getGeometrie () [0];
      float xR = meineOeffnung [i].getGeometrie () [1];
      float yO = meineOeffnung [i].getGeometrie () [2];
      float yU = meineOeffnung [i].getGeometrie () [3];

      if (yZelle <= yU + rZelle + minA && yZelle >= yO - rZelle -minA && xZelle <= xR + rZelle + minA && xZelle >= xL - rZelle -minA)    // nur schlaufen, falls Ber\u00fchrung m\u00f6glich
      {
        if (yZelle <= yU && yZelle >= yO) {             // Ber\u00fchrung links oder rechts
          if (xZelle < xL) {                            // Ber\u00fchrung links
            setBerKoor (xZelle + rZelle, yZelle);
          } 
          else if (xZelle > xR) {                       // Ber\u00fchrung rechts
            setBerKoor (xZelle - rZelle, yZelle);
          }
        } 
        else if (xZelle <= xR && xZelle >= xL) {        // Ber\u00fchrung oben oder unten
          if (yZelle < yO) {                            // Ber\u00fchrung oben
            setBerKoor (xZelle, yZelle + rZelle);
          } 
          else if (yZelle > yU) {                       // Ber\u00fchrung rechts
            setBerKoor (xZelle, yZelle - rZelle);
          }
        } 
        else {                                                                     // Ber\u00fchrung an einer Ecke
          if (sqrt(sq(xL - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {           // Ber\u00fchrung unten links
            setBerKoor (xZelle + rZelle, yZelle - rZelle);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung unten rechts
            setBerKoor (xZelle - rZelle, yZelle - rZelle);
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung oben rechts
            setBerKoor (xZelle - rZelle, yZelle + rZelle);
          } 
          else if (sqrt(sq(xL - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung oben links
            setBerKoor (xZelle + rZelle, yZelle + rZelle);
          }
        }
      }

    }

// R\u00e4nder

    if (xZelle <= rZelle + minA) {                          // Ber\u00fchrung links
      setBerKoor (xZelle - rZelle, yZelle);
    } else if (xZelle >= width - rZelle - minA) {           // Ber\u00fchrung rechts
      setBerKoor (xZelle + rZelle, yZelle);
    } else if (yZelle <= rZelle + minA) {                   // Ber\u00fchrung oben
      setBerKoor (xZelle, yZelle - rZelle);
    } else if (yZelle >= height - rZelle - minA) {           // Ber\u00fchrung rechts
      setBerKoor (xZelle, yZelle + rZelle);
    }
    
    if (Beruehrungszaehler > AnzahlBeruehrungen)
    {
      AnzahlBeruehrungen = Beruehrungszaehler;
      setBeruehrungspunkt ();
    }
    return (Beruehrungszaehler);
  }

  //--------------------------------------------------------------------------------------------------

  public void bewegen_Ber_1 ()
  {
    xZelle += g*(xZelle - Beruehrungspunkt [0])/rZelle;              // Mittelpunkt verschieben
    yZelle += g*(yZelle - Beruehrungspunkt [1])/rZelle;
  }

  //--------------------------------------------------------------------------------------------------

  public void bewegen_Ber_2 ()
  {
    float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
    float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
    float AbstandMitte = sqrt(sq(xMitte -xZelle) + sq(yMitte -yZelle));
    xZelle += g*((xZelle - xMitte)/AbstandMitte);              // Mittelpunkt verschieben
    yZelle += g*((yZelle - yMitte)/AbstandMitte);
  }


  //--------------------------------------------------------------------------------------------------

  public void setBerKoor (float x, float y)
  {
    Beruehrungszaehler++;
    if (Beruehrungszaehler<=2)
    {
      Beruehrungspunkt [Beruehrungszaehler*2-2] = x;    // x-Wert Ber\u00fchrunspunkt
      Beruehrungspunkt [Beruehrungszaehler*2-1] = y;    // y-Wert Ber\u00fchrunspunkt
    }
  }

  //--------------------------------------------------------------------------------------------------

  public void reset ()
  {
    col = Hintergrund;                                           // Zelle l\u00f6schen
    zeichnen ();

    fertig = false;                                              // Variabeln zur\u00fccksetzen
    col = ZelleColor;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }

  //--------------------------------------------------------------------------------------------------

  public boolean getFertig ()                                // Variable "fertig" auslesen     
  {
    return fertig;
  }  

  //--------------------------------------------------------------------------------------------------  

  public float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {
      xZelle, yZelle, rZelle    };
    return Geometrie;
  }  

  //--------------------------------------------------------------------------------------------------

  public void setFertig (boolean f)                           // Variable "fertig" setzen
  {
    fertig = f;
    col = ZelleFertigColor;
    zeichnen ();
  }    

  // --------------------------------------------------------------------------------------------------

  public void setFarbe (int c)                              // Methode: Farbe setzen
  {
    col = c;
  }    

  //--------------------------------------------------------------------------------------------------

  public void setBeruehrungspunkt ()                          // wird in Unterklasse \u00fcberdeckt
  {
    
  }    

  //--------------------------------------------------------------------------------------------------

}
static public void main(String args[]) {   PApplet.main(new String[] { "_070207_Wachstum" });}}